﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using OpenTK;
using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;

using Meshomatic;

namespace CG1.Ex03.Meshes
{
    class Mesh
    {
        #region Properties

        private MeshBatch MBatch;
        private MeshData TmpData, TmpData2;
        private Random Rand = new Random();
        private String objFile, texFile;

        #endregion

        #region Init

        /// <summary>
        /// Set the Mesh. Here you can edit mesh, or improve to better performance if needed.
        /// </summary>
        public Mesh(String ObjFile, String TexFile)
        {
            objFile = ObjFile;
            texFile = TexFile;

            MBatch = new MeshBatch(ObjFile, TexFile);
            TmpData = new ObjLoader().LoadFile(ObjFile);
            TmpData2 = new ObjLoader().LoadFile(ObjFile);
        }

        #endregion

        #region Render And Helper Methods

        /// <summary>
        /// Reload buffer of mesh and render it again.
        /// </summary>
        public void Render()
        {
            MBatch.LoadBuffers(MBatch.m);

            GL.PushMatrix();
            MBatch.DrawBuffer();
            GL.PopMatrix();
        }

        /// <summary>
        /// Set a default. Here this means: load a default data structure one more time.
        /// </summary>
        public void SetDefault()
        {
            MBatch.m = new ObjLoader().LoadFile(objFile);
        }

        #endregion
    }
}
